/*
	comm

	subroutine:
		comm_init();
		comm_end();
		comm_putchar(c); char c;
		c = comm_getchar(COMM_GETCHAR_BLOCK or COMM_GETCHAR_NONBLOCK);

	process:
		comm_read process
		comm_write process
		comm_echo process (only for test)
		zau_con_in process (only for linux)

	queue:
		"CRDQ"
		"CWRQ"
 */
#if 0

#include <linux/tty.h>
#include <linux/tty_flip.h>
#include <linux/console.h>
#include <linux/kbd_kern.h>


//#include "zau-comm.h"
#define _SYS_TYPES_H_
#define _sys_types_h
#define off_t _off_t_dummy
#define time_t _time_t_dummy
#define stat _stat_dummy
#include <bcommlib.h>


#define COMM_QUE_SIZE		(256)
#define KEYQ_QUEUE		(str_to_name("KEYQ"))
//#define COMM_READ_QUEUE		(str_to_name("CRDQ"))
//#define COMM_WRITE_QUEUE	(str_to_name("CWRQ"))

extern void miru(char*,...);
extern OBJECT_NAME proc_fork(void*,int);

static BCOM	*pBCom = NULL;
extern struct tty_driver console_driver;


#if 0
	GetBCommErrorؿǼ륨顼ɤˤĤƼޤ
	顼ͤϰʲͤȤ߹碌ˤʤޤ
BCOM_SUCCES	0	顼̵
BCOM_RXOVER	0x0001	塼Сե򵯤FULLˤʤä
BCOM_OVERRUN	0x0002	С󥨥顼򸡽Ф
BCOM_RXPARITY	0x0004	ѥƥ顼򸡽Ф
BCOM_FRAME	0x0008	FRAMING ERROR򸡽Ф
BCOM_BREAK	0x0010	֥졼򸡽Ф
BCOM_CTSTO	0x0020	CTSॢ
BCOM_DSRTO	0x0040	DSRॢ
BCOM_DCDTO	0x0080	DCD(CD,RLSD)ॢ
BCOM_MODE	0x8000	ݡȤǤʤ⡼ɤꤵ줿
#endif


#if 0
	ܡȥޥ
	̾餫ΥܡװȯȡCOMMӥϽǤޤ륢ܡװȯƤǤʤ褦ˤ٤˥ܡȥޥꤷơǤ̵뤹褦ˤޤʲ˥ܡװ򼨤ޤΥܡװȤ߹碌ơܡȥޥꤷޤ
ABORT_OFF		0x00000004	ڤץ줿
ABORT_AUTO_POWER_OFF	0x00000008	ȥѥ
ABORT_BATT_COVER_OPEN	0x00000020	ӳ
ABORT_FATAL_LOW_BAT	0x00000040	ӻ̤ʤ
ABORT_BREAK		0x00000080	ǡץ줿
ABORT_PCCARD0_EJECTBTN	0x00010000	EJECTܥ󤬲줿
ABORT_PCCARD0_REMOVED	0x00020000	ɤȴ
ABORT_PCCARD0_SHUTDOWN	0x00040000	٤ΰŸȤ
ABORT_PCCARD0_WPCHANGED	0x00080000	饤ȥץƥȤ줿
ABORT_ALL		0xFFFFFFFF	ܡװ
ABORT_MAINUNIT_ALL	0x000000FF	Τܡװ
ABORT_PCCARD0_ALL	0x000F0000	PCSockect#0ܡװ
#endif


/* ͤϽ񤱤ʤäʸޤϥ顼 */
int comm_putchar(char c)
{
	int	r;
	  /**/
	if(pBCom == NULL){
		return 0;
	}
	r = WriteBComm(pBCom, &c, 1);
	if(r < 0){
		r = GetBCommError(pBCom);
		printk("comm_putchar: WriteBComm: error=%d\n",r);
		return -r;
	}
	return 0;
}


/* ͤϽ񤱤ʤäʸޤϥ顼 */
int comm_write(char *buf, int len)
{
	int	r;
	  /**/
	if(pBCom == NULL){
		return 0;
	}
	r = WriteBComm(pBCom, buf, len);
	if(r < 0){
		r = GetBCommError(pBCom);
		printk("comm_write: WriteBComm: error=%d\n",r);
		return -r;
	}
	return len-r;
}


void comm_status(BCOMSTAT *s)
{
	printk("UINT:         Status %08x\n",s->Status);
	printk("int:             Sig %x\n",s->Sig);
	printk("ABORTFLAG: AbortCond %08x\n",s->AbortCond);
	printk("UINT: i       cRxQue %d\n",s->cRxQue);
	printk("UINT:         cTxQue %d\n",s->cTxQue);
	printk("UINT: cRxQueCapacity %d\n",s->cRxQueCapacity);
	printk("UINT: cTxQueCapacity %d\n",s->cTxQueCapacity);
	printk("UINT:         Rsv[3]\n");
	self_sleep(64*60);
}


/* 塼˶ޤԤ */
/* ͤϥ顼 */
int comm_vacant_txque(int timeout)
{
	int	r;
	BCOMSTAT	State;
	  /**/
	if(pBCom == NULL){
		return 0;
	}
	if(timeout < 0){
		timeout = BCOM_WAIT_FOREVER;
	}
	r = WaitChangeBCommState(pBCom, &State, BCOM_EVENT_VACANT_TXQUE, timeout);
	if(r != SUCCESS){
		r = GetBCommError(pBCom);
		printk("comm_vacant_txque: WaitChangeBCommState: error=%d\n",r);
		return -r;
	}
	return 0;
}


/* ƥ塼˽񤭽ޤԤ */
/* ͤϥ顼 */
int comm_write_wait(char *buf, int len)
{
	int	r;
	  /**/
	for(r = len;;){
		r = comm_write(buf, r);
		if(r < 0){
			return r;
		}
	}while(r);
	return 0;
}



#ifdef COMM_WRITE_QUEUE

int comm_putchar_p(char c)
{
	QUEUE_PBOX      pbox;
	  /**/
	pbox.data = &c;
	pbox.timeout = 0;
	pbox.size = 1;
	if(queue_write(COMM_WRITE_QUEUE, &pbox) == -1){
		printk("cannot write comm_write_que\n");
		return 1;
	}
	return 0;
}


static void comm_write_proc(void)
{
	int	r, i, n;
	BCOMSTAT	State;
	QUEUE_PBOX	pbox;
	unsigned char	buf[COMM_QUE_SIZE];
	  /**/
miru("--> " __FUNCTION__);
	pbox.data = buf;
	pbox.timeout = -1;
	for(;;){
		pbox.size = sizeof(buf);
		if(queue_read(COMM_WRITE_QUEUE, &pbox) == -1){
			printk("cannot read comm_write_que\n");
			self_end();
		}
		for(i = 0, n = pbox.size;;){
			r = WriteBComm(pBCom, buf + i, n - i);
			if(r < 0){
				r = GetBCommError(pBCom);
				printk("comm_write_proc: WaitChangeBCommState: error=%d\n",r);
				continue;
			}
			if((i += r) == n){
				break;
			}
			r = WaitChangeBCommState(pBCom, &State, BCOM_EVENT_VACANT_TXQUE, BCOM_WAIT_FOREVER);
			if(r < 0){
				r = GetBCommError(pBCom);
				printk("WaitChangeBCommState: error=%d\n",r);
				continue;
			}
		}
	}
}

#endif /* COMM_WRITE_QUEUE */


static void comm_in_proc(void)
{
	int	x, i, n;
	BCOMSTAT	State;
	struct tty_struct	*tty;
	unsigned char	buf[COMM_QUE_SIZE];
	  /**/
//0214 miru("--> " __FUNCTION__);
	tty = NULL;
	i = n = 0;
	for(;;){
		while(n <= i){
			x = WaitChangeBCommState(pBCom, &State, BCOM_EVENT_DATA_ARRIVE, BCOM_WAIT_FOREVER);
			if(x < 0){
				printk("comm_in_proc: WaitChangeBCommState: ret=%x\n",x);
//0214 				x = GetBCommError(pBCom);
				printk("comm_in_proc: WaitChangeBCommState: error=%d\n",x);
				comm_status(&State);
				continue;
			}
			i = 0;
			n = ReadBComm(pBCom, buf, sizeof(buf)-1);
		}
		x = buf[i++];
		tty = console_driver.table[fg_console];
		if(tty){
#if 0 * 0214
			printk("[si%02x%c]",x,x>=32&&x<=126?x:'.');
#endif
			tty_insert_flip_char(tty, x, 0);
			con_schedule_flip(tty);
		}
	}
}


static void keyq_in_proc(void)
{
	int	x, i, n;
	struct tty_struct	*tty;
	QUEUE_PBOX	pbox;
	unsigned char	buf[COMM_QUE_SIZE];
	  /**/
//0214 miru("--> " __FUNCTION__);
	tty = NULL;
	i = n = 0;
	for(;;){
		while(n <= i){
			pbox.data = buf;
			pbox.timeout = -1;	/* block */
			pbox.size = sizeof(buf);
			if ((x = queue_read(KEYQ_QUEUE, &pbox)) == -2) {
				continue;	/* timeout */
			}else if(x == -1){
				printk("cannot read kybd_read_que\n");
				continue;
			}
			i = 0;
			n = pbox.size;
		}
		x = buf[i++];
		tty = console_driver.table[fg_console];
		if(tty){
#if 0 * 0214
			printk("[ki%02x%c]",x,x>=32&&x<=126?x:'.');
#endif
			tty_insert_flip_char(tty, x, 0);
			con_schedule_flip(tty);
		}
	}
}


#define RECV_QUE_SIZE	(4096)
#define SEND_QUE_SIZE	(2048)
COMMDEV		*pDev;
OBJECT_NAME	comm_in_proc_name;
OBJECT_NAME	comm_write_proc_name;
OBJECT_NAME	keyq_in_proc_name;


int comm_init(int stack_size)
{
	BCOMMODE mode;
	  /**/
	pBCom = NULL;
	if((pDev = LockCommDev(BLTIN_15PIN_DEV)) == NULL){
		return 0;
	}
	if((pBCom = OpenBComm(pDev, RECV_QUE_SIZE, SEND_QUE_SIZE)) == NULL){
		UnlockCommDev(pDev);
		return 0;
	}
	GetModeBComm(pBCom, &mode);
	mode.ByteSize = DATABIT_8;
	mode.Parity = PARITY_NONE;
	mode.StopBits = STOPBIT_1;
	mode.BaudRate = 38400;
	mode.fTxCtsLook = 1;
	mode.fTxDsrLook = 0;
	mode.fRxDtrDrive = 0;
	mode.fRxRtsDrive = 1;
	mode.fRxXSend = 0;
	mode.fTxXLook = 0;
	SetModeBComm(pBCom, &mode);
/* let's fork */
#ifdef COMM_READ_QUEUE
	if(queue_create(COMM_READ_QUEUE, 4, COMM_QUE_SIZE) == -1){
		printk("cannot create comm_read_que\n");
	}
#endif /* COMM_READ_QUEUE */
	comm_in_proc_name = proc_fork(comm_in_proc, stack_size);
#ifdef COMM_WRITE_QUEUE
	if(queue_create(COMM_WRITE_QUEUE, 4, COMM_QUE_SIZE) == -1){
		printk("cannot create comm_write_que\n");
	}
	comm_write_proc_name = proc_fork(comm_write_proc, stack_size);
#endif /* COMM_WRITE_QUEUE */
/* opening message */
{ char s[] = "\n" __FILE__ ":" __FUNCTION__ " comm 8bit parity-none 1stop 38400 dayo\n", *p, *q; for(p = s, q = s + sizeof(s); p < q; ++p) comm_putchar(*p);}
	return 1;
}


int comm_end(void)
{
	if (pBCom) CloseBComm(pBCom);
	pBCom = NULL;
	if (pDev) UnlockCommDev(pDev);
	proc_stop(comm_in_proc_name);
	proc_delete(comm_in_proc_name);
#ifdef COMM_WRITE_QUEUE
	proc_stop(comm_write_proc_name);
	proc_delete(comm_write_proc_name);
#endif
	return 1;
}


int keyq_init(int stack_size)
{
	keyq_in_proc_name = proc_fork(keyq_in_proc, stack_size);
	return 1;
}


int keyq_end(void)
{
	proc_stop(keyq_in_proc_name);
	proc_delete(keyq_in_proc_name);
	return 1;
}


/* EOF */

#endif
