/*
	Copyright (c) 1992, 1993, 1994, 1995  AXE,Inc.
 */

/*

	ץδ

*/

#ifndef _PROC_H
#define _PROC_H


#include <regs.h>

#include "mem_rt.h"
#include "proc_mem.h"

/* #define IDLE_PROC_NAME "_" */

/***  #include "procdef.h" ***/

/* struct Proc_info .stat */
#define NO_EXIST	(0x0)		/* ץ¸ߤʤ */
#define EXIST		(0x1)		/* ץμ¹ԤϻϤޤäƤʤ */
#define READY		(0x2)		/* ¹Բǽ */
#define ACTIVE		(0x3)		/* ¹ */
#define SLEEP		(0x4)		/* ॢդԵ */
#define WAIT		(0x5)		/* ॢ̵Ե */
#define ZOMBIE		(0x6)		/*  */
#define KERNEL_SERV	(0x7)		/* ݥͥ...*/

/* struct Proc_info .waitstat */
#define WAIT_NONE	(0x0)		/* ԤäƤΤϤʤ */
#define WAIT_QUE_READ	(0x1)		/* 塼ɤ߹ߤԤ */
#define WAIT_QUE_WRITE	(0x2)		/* 塼񤭹ߤԤ */
#define WAIT_EVENT	(0x3)		/* ٥Ԥ */
#define WAIT_SEMAPHORE	(0x4)		/* ޥեԤ */
/* #define WAIT_SLEEP	(0x5) */	/* ʵsleep */

/**/

struct Proc_link{			/* ץ */
	struct Proc_info *pre;		/* Υץ */
	struct Proc_info *next;		/* Υץ */
};
#define PROC_LINK	struct Proc_link



struct Proc_info{			/* ץ */
	OBJECT_NAME	name;		/* ץ̾ */
	BYTE4		objType;
	OBJECT_NAME	creator;	/*  */

/*	PROC_LIST	waitprocess;	/* ObjectԤΥץ*/
/*	JOEV		joev;		/**/

	BYTE4		type;		/* thread or task */
	BYTE4		stat;		/* ץξ */
	BYTE4		waitstat;	/* ץԤξ */
	OBJECT_NAME	waitlist_name;	/* ץԤƤꥹ̾ */
	BYTE4		priority_init;	/* ͥٽ */
	UBYTE4		priority;	/* ͥ */
	BYTE4		timeslice;	/* timeslice */
	MEM_INFO	*stack;		/* å */
	REGS_AREA	regs;		/* 쥸 */
	BYTE4		active_start;	/* ǸACTIVE֤Ϥ줿 */
	BYTE4		active_end;	/* ǸACTIVE֤λ */
	UBYTE4		timeout;	/* ॢȻ */
	OBJECT_NAME	sleepby;	/* sleep줿ץ̾ */
	PROC_LINK	timeorder;	/* timeoutΥץν֤򼨤 */
	PROC_LINK	order;		/* timeoutʳΥץ֤򼨤 */
	OBJECT_NAME	code;		/* ץॳ̾ */
	MEM_INFO	*data;		/* ǡΰ */
/*	OBJECT_NAME	bss;*/		/* bssΰ̾ */
	MEM_LIST        *mlisth;	/* ץνͭꥹ */ 
	BYTE4		strbuf[7];	/* ƥॳι¤ΤΥХåե */
	BYTE4		signal;

	BYTE4		life;		/* ץtick */
	BYTE4		sys_life;	
	BYTE4		active_cnt;	/* ץactiveˤʤä */
#ifdef USE_MMU_TOUCH
	BYTE4		mmumap_cnt;	/*   mmuΥơ֥񤭴 */
#endif USE_MMU_TOUCH
};
#define PROC_INFO	struct Proc_info


struct Proc_list{
	PROC_INFO *top;		/* ƬΥץ */
	PROC_INFO *last;		/* ǸΥץ */
};
#define PROC_LIST	struct Proc_list



extern PROC_INFO *ActiveProcess;
					/* ¹Υץ̾ */


#define PSIG_DBGSTOP		(0)


void ProcInit();
/*
	void ProcInit();

	ƤΥץ
*/


void ProcFirstSet();
/*
	void ProcFirstSet( regs )
	REGS_AREA *regs;

	Υץ򥻥åȤ
	ϣӵư˻
*/


/******************************************************************************/

int ProcCreate();
/*
	int ProcCleate(regs,name,pinfo);
	OBJECT_NAME name;
	PROC_INI pinfo;

	ץ
*/


int ProcDelete();
/*
	int ProcDelete( name )
	OBJECT_NAME name;
	֤			顼λ-1

	EXISTΥץκ
*/


int ProcStart();
/*
	int ProcStart( name )
	OBJECT_NAME name;

	ץ֤EXISTREADYˤ
*/


void ProcStop();
/*
	void ProcStop( regs, name )
	REGS_AREA *regs;
	OBJECT_NAME name;

	ץ֤EXISTˤ
	꥿󤷤ޤ
*/



void ProcSelfDelete();
/*
	void ProcSelfDelete( regs )
	REGS_AREA *regs;
	꥿󤷤ޤ

	ץä
*/


void ProcZombie();
/*
  void
  ProcZombie( regs, proc )
  REGS_AREA *regs;
  PROC_INFO *proc;

  ץZOMBIE롣
*/

void ProcSleep();
/*
	int ProcSleep(regs,name,time)
	REGS_AREA *regs;
	OBJECT_NAME name;
	BYTE4 time;

	ץsleep
	꥿󤷤ޤ

*/


int ProcWakeup();
/*
	int ProcWakeup(name)
	OBJECT_NAME name;
	֤			顼λ-1

	SLEEPץ򵯤
*/


BYTE4 ProcGetLife();
/*
	BYTE4 ProcGetLife(name)
	OBJECT_NAME name;

	ץ֤֤
*/


int ProcSetslice();
/*
	int
	ProcSetslice( name, s )
	OBJECT_NAME name;
	BYTE4 s;
	֤			顼λ-1

	timesliceͤꤹ
*/


int ProcSetpriority();
/*
	int
	ProcSetpriority( name, s )
	OBJECT_NAME name;
	BYTE4 s;
	֤			顼λ-1

	priorityͤꤹ
*/


int ProcSetgrab();
/*
	int
	ProcSetGrasp( name, grasp )
	OBJECT_NAME name;
	int grasp;
	֤			顼λ-1

	ץGRASPѹ
*/


/******************************************************************************/


void ProcSleepoutCheck();
/*
	void ProcSleepoutCheck()

	SLEEPƤץǵץ
	༡Ƥ
*/



void ProcTimeoutCheck();
/*
	void ProcTimeoutCheck( regs );
	REGS_AREA *regs;

	ߤΥץ¹Ի֤ȤԤǧ
	ȤԤץڤؤԤ
*/


void ProcZombieCheck();
/*
  void
  ProcZombieCheck()

  ZOMBIEФ򤹤٤ƺ
*/



int ProcWait();
/*
	int ProcWait( regs, proc, waitstat, list, timeout )
	REGS_AREA	regs;		ƥ֥ץΥ쥸
	PROC_INFO	*proc;		Ե֤ˤץ
	BYTE4		waitstat;	Ե֤η
	OBJECT_NAME	list_name;	Ե¸ߤ륪֥Ȥλ
							ʰָԵޤ
					waitstatWAIT_NONEλϻȤޤ
	UBYTE4		timeout;	ॢȤ
	֤	顼ΤȤ-1֤ޤλϥץڤؤϵޤ

	ץ̲餹⤷Ե˾֤ˤޤ
	ץACTIVEλϡץڤؤԤޤ
	list_nameǤäꡢߤΥץ֤۾Ǥ
	顼Ȥʤ
*/



void ProcWakeupList();
/*
	void ProcWakeup( proc, list )
	PROC_INFO	*proc;		Ե֤鵯ץ
	֤				꥿󤷤ޤ

	ԵΥץŪ˵
*/



void ProcSchedule( REGS_AREA *regs);
/*
	void ProcSchedule( regs )
	REGS_AREA *regs;

	ƥ֥ץѹ
	ƥ֥ץactive_end,life򹹿
*/


void ProcScheduleNoPreemption( REGS_AREA *regs);
/*
	void ProcSchedule( regs )
	REGS_AREA *regs;

	ƥ֥ץѹ
	ƥ֥ץactive_end,life򹹿ʤ
										   ~~~~~~~~~~
	add 1998/07/09 K.Tsuneyoshi for PI-2
*/


void IdleSchedule();
/*
  void
  IdleSchedule(regs)
  REGS_AREA *regs;

  ɥץƤӽФ졢ॢȤץõ
  READYʥץСƥȥåԤ
*/


int ProcSigSet();
/*
int
ProcSigSet(name,sig)
OBJECT_NAME name;
int sig;
*/

int ProcSigClear();
/*
int
ProcSigClear(name,sig)
OBJECT_NAME name;
int sig;
*/

#endif _PROC_H
